 function x = cgaussp (A, b,p) 
%---------------------------------------------------
% USES P-DIGIT ARITHMETIC -- 
%  function x = guass(A, b)
%  solves A x  = b by Gaussian elimination with
%  partial pivoting/ 
%---------------------------------------------------
 n = size(A,1) ;
 A = chop([A,b], p) 
 for k=1:n-1 
   [t, ip] = max(abs(A(k:n,k))); 
   ip = ip+k-1 
%% swap 
    temp = A(k,k:n+1) ;
    A(k,k:n+1) =  A(ip,k:n+1); 
    A(ip,k:n+1) = temp;
%%
     for i=k+1:n
     piv =  chop( A(i,k) / A(k,k) ,p)  ; 
     A(i,k:n+1) =  chop( A(i,k:n+1) - chop( piv*A(k,k:n+1),p) ,p) ;
   end
 A 
 end 
 x = cbacksolv(A,A(:,n+1),p); 
