function [res,sol] = gmres0 (A,rhs,x,im,tol,maxits) 
tolmac = eps;
its = 0;
ierr = 0 ;
sol = x; 
%%
while (its < maxits) 
     vv(:,1) = rhs - A*sol  ;
     ro = norm(vv(:,1),2)  ; 
     if (its  == 0) 
     tol1=tol*ro  ;
     end  ; 
     if (ro < tol1 | its > maxits)  
     return
     end
     t = 1.0/ ro   ;
     vv(:,1) = vv(:,1) * t  ;
%%----------  initialize 1-st term  of rhs of hessenberg system..  ;
      rs(1) = ro  ;
      i = 0  ;
 while (i < im  &  (ro  >  tol1)  &  its < maxits)
      i=i+1  ;
      its = its + 1  ;
      i1 = i + 1  ;
      vv(:,i1) = A*vv(:,i)  ;
%---------- modified GS  ;
      for j=1:i
         t = vv(:,j)'*vv(:,i1)  ;
         hh(j,i) = t  ;
	 vv(:,i1) = 	 vv(:,i1) - t*vv(:,j)  ;
      end  
      t = norm(vv(:,i1),2)  ;
      hh(i1,i) = t  ;
      if (t  ~= 0.0)  
        t = 1.0 / t  ;
        vv(:,i1) = vv(:,i1)*t  ;
      end  
%%
    if (i ~= 1) 
%---------- apply previous transformations on i-th column of h  ;
      for k=2:i 
         k1 = k-1  ;
         t = hh(k1,i)  ;
         hh(k1,i) = c(k1)*t + s(k1)*hh(k,i)  ;
         hh(k,i) = -s(k1)*t + c(k1)*hh(k,i)  ;
      end  ; 
     end  ; %% IF 
%%
     gam = sqrt(hh(i,i)^2 + hh(i1,i)^2)  ;
     gam = max(tolmac,gam);
%---------- determine plane rotation & update rhs of LS Pb
     c(i) = hh(i,i)/gam  ;
     s(i) = hh(i1,i)/gam  ;
     rs(i1) = -s(i)*rs(i)  ;
     rs(i) =  c(i)*rs(i)  ;
%---------- determine res. norm. and test for convergence
     hh(i,i) = c(i)*hh(i,i) + s(i)*hh(i1,i)  ;
     ro = abs(rs(i1))  ;
     res(its) = ro   ; 
   end 
%---------- compute solution. solve upper triangular system
     rs(i) = rs(i)/hh(i,i)  ;
     for  k=i-1:-1:1  ;
        t=rs(k)  ;
        for j=k+1:i  ;
           t = t-hh(k,j)*rs(j)  ;
        end  ;
        rs(k) = t/hh(k,k)  ;
     end  ;
%---------- now form linear combination to get solution 
     for j=1:i 
        sol = sol +rs(j)* vv(:,j)   ;
     end 
 end
