  function T = tridiag(a, b, c, n)
%% function T = tridiag(a, b, c, n)
%% makes the matrix tridiag(a,b,c) of size n x n 
%% a = subdiag, b = diag, c = super-diag
%% 
 sub = diag(ones(n-1,1),-1);
 T = b*eye(n) + a .* sub + c .* sub';
% 
