 function [L,U] = kij(A) 
%----------------------------------------------
% function [L,U] = kij (A) 
% LU factorization of A. Uses kij variant of GE
%----------------------------------------------
n = size(A,1) ;
for k=1:n-1
    for i=k+1:n
        A(i,k) = A(i,k)/A(k,k);
        A(i,k+1:n) = A(i,k+1:n) - A(i,k)*A(k,k+1:n);
    end
end 
L = diag(ones(n,1)) + tril(A,-1);
U = triu(A);
