 function [A] = lufact (A) 
%---------------------------------------------
%  function [L,U] = lufact (A) 
%  performs LU factorization of a matrix a 
%---------------------------------------------
 n = size(A,1) ;
 for k=1:n-1 
     A(k+1:n,k) = A(k+1:n,k)/A(k,k);
     for j=k+1:n
       A(k+1:n,j)=A(k+1:n,j)-A(k+1:n,k)*A(k,j);
     end
 end
